| API Docs for SAX and DOM |

Main Page | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Class Members | File Members | Related Pages

# DOMXPathEvaluator Class Reference

The evaluation of XPath expressions is provided by `DOMXPathEvaluator`. More...

Inheritance diagram for DOMXPathEvaluator:

[legend]
List of all members.

## Public Member Functions

Destructor
virtual | ~DOMXPathEvaluator ()
| Destructor.
Functions introduced in DOM Level 3
virtual const DOMXPathExpression * | createExpression (const XMLCh *expression, const DOMXPathNSResolver *resolver)=0
| Creates a parsed XPath expression with resolved namespaces.
virtual const DOMXPathNSResolver * | createNSResolver (DOMNode *nodeResolver)=0
| Adapts any DOM node to resolve namespaces so that an XPath expression can be easily evaluated relative to the context of the node where it appeared within the document.
virtual void * | evaluate (const XMLCh *expression, DOMNode *contextNode, const DOMXPathNSResolver *resolver, unsigned short type, void *result)=0
| Evaluates an XPath expression string and returns a result of the specified type if possible.

## Protected Member Functions

Hidden constructors
| DOMXPathEvaluator ()

## Detailed Description

The evaluation of XPath expressions is provided by `DOMXPathEvaluator`.

In a DOM implementation which supports the XPath 3.0 feature, the `DOMXPathEvaluator` interface will be implemented on the same object which implements the Document interface permitting it to be obtained by casting or by using the DOM Level 3 getInterface method. In this case the implementation obtained from the Document supports the XPath DOM module and is compatible with the XPath 1.0 specification. Evaluation of expressions with specialized extension functions or variables may not work in all implementations and is, therefore, not portable. XPathEvaluator implementations may be available from other sources that could provide specific support for specialized extension functions or variables as would be defined by other specifications.

Since:
  DOM Level 3

## Constructor & Destructor Documentation

DOMXPathEvaluator::DOMXPathEvaluator | ( |  | ) | `[protected]`

virtual DOMXPathEvaluator::~DOMXPathEvaluator | ( |  | ) | `[virtual]`

| Destructor.

## Member Function Documentation

virtual const DOMXPathExpression* DOMXPathEvaluator::createExpression | ( | const XMLCh * | expression,
|  | const DOMXPathNSResolver * | resolver
| ) | `[pure virtual]`

Creates a parsed XPath expression with resolved namespaces.

This is useful when an expression will be reused in an application since it makes it possible to compile the expression string into a more efficient internal form and preresolve all namespace prefixes which occur within the expression.

Parameters:

  | expression | of type XMLCh - The XPath expression string to be parsed.
  | resolver | of type `XPathNSResolver` - The resolver permits translation of all prefixes, including the xml namespace prefix, within the XPath expression into appropriate namespace URIs. If this is specified as null, any namespace prefix within the expression will result in `DOMException` being thrown with the code NAMESPACE_ERR.

Returns:
  `XPathExpression` The compiled form of the XPath expression.

Exceptions:

  | <code>XPathException</code> | INVALID_EXPRESSION_ERR: Raised if the expression is not legal according to the rules of the `DOMXPathEvaluator`.
  | DOMException | NAMESPACE_ERR: Raised if the expression contains namespace prefixes which cannot be resolved by the specified `XPathNSResolver`.

Since:
  DOM Level 3

virtual const DOMXPathNSResolver* DOMXPathEvaluator::createNSResolver | ( | DOMNode * | nodeResolver | ) | `[pure virtual]`

Adapts any DOM node to resolve namespaces so that an XPath expression can be easily evaluated relative to the context of the node where it appeared within the document.

This adapter works like the DOM Level 3 method lookupNamespaceURI on nodes in resolving the namespaceURI from a given prefix using the current information available in the node's hierarchy at the time lookupNamespaceURI is called. also correctly resolving the implicit xml prefix.

Parameters:

  | nodeResolver | of type `DOMNode` The node to be used as a context for namespace resolution.

Returns:
  `XPathNSResolver` `XPathNSResolver` which resolves namespaces with respect to the definitions in scope for a specified node.

virtual void* DOMXPathEvaluator::evaluate | ( | const XMLCh * | expression,
|  | DOMNode * | contextNode,
|  | const DOMXPathNSResolver * | resolver,
|  | unsigned short | type,
|  | void * | result
| ) | `[pure virtual]`

Evaluates an XPath expression string and returns a result of the specified type if possible.

Parameters:

  | expression | of type XMLCh The XPath expression string to be parsed and evaluated.

  contextNode

  of type `DOMNode` The context is context node for the evaluation of this XPath expression. If the `DOMXPathEvaluator` was obtained by casting the `DOMDocument` then this must be owned by the same document and must be a `DOMDocument`, `DOMElement`, `DOMAttribute`, `DOMText`, `DOMCDATASection`, `DOMComment`, `DOMProcessingInstruction`, or `XPathNamespace` node. If the context node is a `DOMText` or a `DOMCDATASection`, then the context is interpreted as the whole logical text node as seen by XPath, unless the node is empty in which case it may not serve as the XPath context.

  | resolver | of type `XPathNSResolver` The resolver permits translation of all prefixes, including the xml namespace prefix, within the XPath expression into appropriate namespace URIs. If this is specified as null, any namespace prefix within the expression will result in `DOMException` being thrown with the code NAMESPACE_ERR.
  | type | of type unsigned short - If a specific type is specified, then the result will be returned as the corresponding type. For XPath 1.0 results, this must be one of the codes of the `XPathResult` interface.
  | result | of type void* - The result specifies a specific result object which may be reused and returned by this method. If this is specified as null or the implementation does not reuse the specified result, a new result object will be constructed and returned. For XPath 1.0 results, this object will be of type `XPathResult`.

Returns:
  void* The result of the evaluation of the XPath expression. For XPath 1.0 results, this object will be of type `XPathResult`.

Exceptions:

  | <code>XPathException</code> | INVALID_EXPRESSION_ERR: Raised if the expression is not legal according to the rules of the `DOMXPathEvaluator` TYPE_ERR: Raised if the result cannot be converted to return the specified type.
  | DOMException | NAMESPACE_ERR: Raised if the expression contains namespace prefixes which cannot be resolved by the specified `XPathNSResolver`. WRONG_DOCUMENT_ERR: The Node is from a document that is not supported by this `DOMXPathEvaluator`. NOT_SUPPORTED_ERR: The Node is not a type permitted as an XPath context node or the request type is not permitted by this `DOMXPathEvaluator`.

The documentation for this class was generated from the following file:

- DOMXPathEvaluator.hpp

Copyright © 1994-2004 The Apache Software Foundation. All Rights Reserved.